# class Crystal::Macros::Select

- Crystal::Macros::Select
- Crystal::Macros::ASTNode

##
Overview

A `select` expression.

Every expression `node` is equivalent to:

    select
    {% for when_clause in node.whens %}
      {{ when_clause }}
    {% end %}
    {% else_clause = node.else %}
    {% unless else_clause.is_a?(Nop) %}
      else
        {{ else_clause }}
    {% end %}
    end

##
Defined in:

compiler/crystal/macros.cr

##
Instance Method Summary

- #else : ASTNode

  Returns the `#else` of this `select`.

- #whens : ArrayLiteral(When)

  Returns the `when`s of this `select`.

### Instance methods inherited from class `Crystal::Macros::ASTNode`

!=(other : ASTNode) : BoolLiteral !=, ==(other : ASTNode) : BoolLiteral ==, class_name : StringLiteral class_name, column_number : StringLiteral | NilLiteral column_number, doc : StringLiteral doc, doc_comment : MacroId doc_comment, end_column_number : StringLiteral | NilLiteral end_column_number, end_line_number : StringLiteral | NilLiteral end_line_number, filename : StringLiteral | NilLiteral filename, id : MacroId id, is_a?(type : TypeNode) : BoolLiteral is_a?, line_number : StringLiteral | NilLiteral line_number, nil? : BoolLiteral nil?, raise(message) : NoReturn raise, stringify : StringLiteral stringify, symbolize : SymbolLiteral symbolize, warning(message : StringLiteral) : NilLiteral warning

##
Instance Method Detail

def else : ASTNode #

Returns the `#else` of this `select`.

def whens : ArrayLiteral(When) #

Returns the `when`s of this `select`.